// -*- c++ -*-

/*
    Copyright (C) 2009, 2010, 2011  David Psenicka
    This file is part of FOMUS.

    FOMUS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FOMUS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
  ALL COMMENTS IN THIS FILE ARE OLD AND HAVEN'T BEEN UPDATED YET!
*/

#ifndef FOMUS_MODTYPES_H
#define FOMUS_MODTYPES_H

#include "basetypes.h"

#ifdef __cplusplus
extern "C" {
#endif
  
  // --------------------------------------------------------------------------------
  // types

  typedef void* module_obj;

  typedef void* module_noteobj;
  typedef void* module_measobj;
  typedef void* module_partobj;
  typedef void* module_markobj;
  typedef void* module_instobj;
  typedef void* module_percinstobj;
  typedef void* module_staffobj;
  typedef void* module_clefobj;
  
  // module categories
  enum module_type {
    module_nomodtype,
    module_modinternal,
    module_modinput,
    module_modoutput,
    module_modengine,
    module_modaux,
    module_modmeas,
    module_modtquant,
    module_modpquant,
    module_modcheck,
    module_modtpose,
    module_modvoices,
    module_modmarkevs,
    module_modprune,
    module_modvmarks,
    module_modaccs,
    module_modcautaccs,
    module_modstaves,
    module_modrstaves,
    module_modsmarks,
    module_modocts,
    module_moddynamics,
    module_moddivide,
    module_modmerge,
    module_modbeams,
    module_modmarks,
    module_modmarklayouts,
    module_modparts,
    module_modmetaparts,
    module_modpercnotes,
    module_modspecial,
  };

  enum parts_grouptype {
    parts_nogroup,
    parts_group,
    parts_choirgroup,
    parts_grandstaff
  };

  enum module_clefids {
    clef_subbass_8down,
    clef_bass_8down,
    clef_c_baritone_8down,
    clef_f_baritone_8down,
    clef_tenor_8down,
    clef_subbass,
    clef_alto_8down,
    clef_bass,
    clef_mezzosoprano_8down,
    clef_c_baritone,
    clef_f_baritone,
    clef_soprano_8down,
    clef_tenor,
    clef_subbass_8up,
    clef_treble_8down,
    clef_alto,
    clef_bass_8up,
    clef_mezzosoprano,
    clef_c_baritone_8up,
    clef_f_baritone_8up,
    clef_soprano,
    clef_tenor_8up,
    clef_treble,
    clef_alto_8up,
    clef_mezzosoprano_8up,
    clef_soprano_8up,
    clef_treble_8up,
    clef_percussion,
    clef_nclefs
  };

  enum module_barlines {
    barline_normal,
    barline_dotted,
    barline_dashed,
    barline_double,
    barline_initial,
    barline_final,
    barline_initfinal,
    barline_repeatleft,
    barline_repeatright,
    barline_repeatleftright
  };

  enum module_markpos {
    markpos_notehead, // most common default
    markpos_above,
    markpos_below,
    // the rest are converted to one of the above three by marks.cc
    markpos_prefabove, // 2nd most common default
    markpos_prefbelow,
    markpos_prefmiddleorabove, // above if there is one staff only
    markpos_prefmiddleorbelow
  };
  
  enum module_markids {
    mark_staccato,
    mark_staccatissimo,
    mark_accent,
    mark_tenuto,
    mark_marcato,
    mark_mezzostaccato,
    mark_harm,
    mark_open,
    mark_stopped,
    mark_snap,
    mark_tempo,
    mark_upbow,
    mark_downbow,
    mark_damp,
    mark_snappizz,
    mark_salt,
    mark_ric,
    mark_lv,
    mark_flt,
    mark_slap,
    mark_breath,
    mark_pizz,
    mark_arco,
    mark_mute,
    mark_unmute,
    mark_vib,
    mark_moltovib,
    mark_nonvib,
    mark_legato,
    mark_moltolegato,
    mark_nonlegato,
    mark_spic,
    mark_tall,
    mark_punta,
    mark_pont,
    mark_tasto,
    mark_legno,
    mark_flaut,
    mark_etouf,
    mark_table,
    mark_cuivre,
    mark_bellsup,
    mark_ord,
    mark_break_before,
    mark_break_after,
    mark_fermata,
    mark_fermata_short,
    mark_fermata_long,
    mark_fermata_verylong,
    mark_arpeggio,
    mark_arpeggio_up,
    mark_arpeggio_down,
    mark_gliss_before,
    mark_gliss_after,
    mark_port_before,
    mark_port_after,
    mark_breath_before,
    mark_breath_after,
    mark_longtrill,
    mark_longtrill2,
    mark_trem,
    mark_trem2,
    mark_natharm_sounding,
    mark_artharm_sounding,
    mark_natharm_touched,
    mark_artharm_touched,
    mark_artharm_base,
    mark_natharm_string,
    mark_sul,
    mark_sf,
    mark_sff,
    mark_sfff,
    mark_sfz,
    mark_sffz,
    mark_sfffz,
    mark_fz,
    mark_ffz,
    mark_fffz,
    mark_rfz,
    mark_rf,
    mark_pppppp,
    mark_ppppp,
    mark_pppp,
    mark_ppp,
    mark_pp,
    mark_p,
    mark_mp,
    mark_ffff,
    mark_fff,
    mark_ff,
    mark_f,
    mark_mf,
    mark_fp,
    mark_fzp,
    mark_sfp,
    mark_sfzp,
    mark_dyn,
    mark_slur_begin,
    mark_slur_end,
    mark_slur_cont,
    mark_dottedslur_begin,
    mark_dottedslur_end,
    mark_dottedslur_cont,
    mark_dashedslur_begin,
    mark_dashedslur_end,
    mark_dashedslur_cont,
    mark_phrase_begin,
    mark_phrase_end,
    mark_phrase_cont,
    mark_dottedphrase_begin,
    mark_dottedphrase_end,
    mark_dottedphrase_cont,
    mark_dashedphrase_begin,
    mark_dashedphrase_end,
    mark_dashedphrase_cont,
    mark_graceslur_begin,
    mark_graceslur_end,
    mark_graceslur_cont,
    mark_cresc_begin,
    mark_cresc_end,
    mark_cresc_cont,
    mark_dim_begin,
    mark_dim_end,
    mark_dim_cont,
    mark_ped_begin,
    mark_ped_end,
    mark_ped_cont,
    mark_text,
    mark_italictextabove,
    mark_italictextabove_begin,
    mark_italictextabove_end,
    mark_italictextabove_cont,
    mark_italictextbelow,
    mark_italictextbelow_begin,
    mark_italictextbelow_end,
    mark_italictextbelow_cont,
    mark_stafftext,
    mark_stafftext_begin,
    mark_stafftext_end,
    mark_stafftext_cont,
    mark_vocal_text,
    mark_tie,
    mark_tuplet_begin,
    mark_tuplet_end,
    mark_graceslash,
    mark_nmarks
  };

  // fomus will pass the fomus_data object to `run' function if module_all,
  // a part object if module_bypart, and a meas object if module_bymeas
  enum module_iter_type {
    module_all = 0x0, // these groups can be combined (ex. by part & by voice)
    module_bypart = 0x1,
    module_bymeas = 0x2,
    module_bymeasgroups = 0x4,

    module_byvoice = 0x8, // everything else is either/or or neither
    module_bystaff = 0x10,

    module_nograce = 0x20,
    module_graceonly = 0x40,
    
    module_norests = 0x80,
    module_restsonly = 0x100,

    module_firsttied = 0x200, // combine these three, or none for all
    module_midtied = 0x400,
    module_lasttied = 0x800,

    module_noperc = 0x1000,
    module_perconly = 0x2000,

    module_noinvisible = 0x4000 // skip invisible notes (not rests)
  };
  
  // types and structs for defining module variables
  enum module_value_type {
    module_none, // used only for info queries, not by modules!
    
    module_bool, // for SETTING TYPE only, same as an int, only parsing is different
    module_int,
    module_float,
    module_rat,
    module_number, // for SETTING TYPE only, NOT a VALUE TYPE
    module_notesym, // for SETTING TYPE only
    module_string,
    module_stringnum, // for MARKS only--args can include both a string and a number
    
    module_list, // everything after this must be some kind of list! (for `freevalue' function to catch possible errors)
    module_list_nums, // for setting, must use more specific list type...
    module_list_strings,
    module_symmap_nums,
    module_symmap_strings,
    module_list_numlists,
    module_list_stringlists,
    module_symmap_numlists,
    module_symmap_stringlists,
    module_special
  };

  struct module_value;
  struct module_list {
    int n;
    struct module_value* vals;
  };
  union module_value_val {
    fomus_int i;
    fomus_float f;
    struct fomus_rat r;
    const char* s;
    struct module_list l;
  };
  struct module_value {
    enum module_value_type type; // the type
    union module_value_val val;
  };
  
  enum module_setting_loc {
    module_noloc, // used only for info queries, not by modules!
    module_locscore,
    module_locimport,
    module_locexport,
    module_locinst,
    module_locpercinst,
    module_locpartmap,
    module_locpart, // implies global
    module_locmeasdef,
    module_locstaff,
    module_locclef,
    module_locnote, // implies instpartmeas and global
  };
  
  // type for variable validation function
  typedef int (*module_valid_fun)(struct module_value val); // must return true/false and optionally set ERR string to error message
  
  // struct for registering a FOMUS variable
  struct module_setting {
    const char* name; // unique variable name, mandatory
    enum module_value_type type;
    const char* descdoc; // documentation string (can be NULL)
    const char* typedoc; // can be NULL
    struct module_value val; // default value
    enum module_setting_loc loc; // bit ORed allowed locations
    module_valid_fun valid; // can be NULL--this is usually the one to set
    int uselevel; // if other than 0 (often/always set), set to 1-3 (1=details like number of chars in tab space, 2=sometimes, 3=seldom used/expert)
  };

  struct module_mark {
    const char* name;
    enum module_value_type type; // none, numb, string or stringnumb
    unsigned int props;
    const char* doc;
  };

  typedef int (*valid_int)(fomus_int val);
  typedef int (*valid_rat)(struct fomus_rat val);
  typedef int (*valid_num)(struct module_value val);
  typedef int (*valid_string)(const char* val);
  typedef int (*valid_listint)(int n, fomus_int val);
  typedef int (*valid_listrat)(int n, struct fomus_rat val);
  typedef int (*valid_listnum)(int n, const struct module_value* val);
  typedef int (*valid_liststring)(int n, const char* val);
  typedef int (*valid_listval)(int n, struct module_value val);
  typedef int (*valid_mapint)(int n, const char* sym, fomus_int val);
  typedef int (*valid_maprat)(int n, const char* sym, struct fomus_rat val);
  typedef int (*valid_mapnum)(int n, const char* sym, const struct module_value* val);
  typedef int (*valid_mapstring)(int n, const char* sym, const char* val);
  typedef int (*valid_mapval)(int n, const char* sym, struct module_value val);

  enum module_bound {
    module_nobound,
    module_incl,
    module_excl
  };

  struct module_objlist {
    int n;
    module_obj* objs;
  };

  struct module_intslist {
    int n;
    const int* ints;
  };
  struct module_ratslist {
    int n;
    const struct fomus_rat* rats;
  };
  struct module_markslist {
    int n;
    const module_markobj* marks;
  };

  struct module_noteparts {
    struct fomus_rat note, acc1, acc2, oct;
  };
  struct module_keysigref {
    struct fomus_rat acc1, acc2;
  };
  
  typedef void (*modfun_init)();
  typedef void (*modfun_free)();
  typedef const char* (*modfun_initerr)();
  
  typedef void* (*modfun_newdata)(FOMUS f); // modcbacks.h
  typedef void (*modfun_freedata)(void* data);
  typedef const char* (*modfun_longname)();
  typedef const char* (*modfun_author)();
  typedef const char* (*modfun_doc)();
  typedef const char* (*modfun_err)(void* data);
  typedef enum module_type (*modfun_type)();
  typedef const char* (*modfun_engine)(void* m);
  typedef int (*modfun_getsetting)(int n, struct module_setting* set, int id);
  typedef int (*modfun_itertype)(); // returns module_iter_type as int
  typedef int (*modfun_priority)(); // modmod.h
  typedef void (*modfun_fillinterface)(void* moddata, void* iface);
  typedef int (*modfun_interfaceid)();
  typedef int (*modfun_sameinst)(module_obj a, module_obj b);  
  typedef void (*modfun_ready)();
  
  typedef const char* (*modinoutfun_getext)(int n); // modinout.h
  typedef const char* (*modinoutfun_getloadid)();
  typedef int (*modinfun_load)(FOMUS f, void* data, const char* fn, int isfile);
  typedef void (*modoutfun_write)(FOMUS f, void* data, const char* fn);
  typedef int (*modoutfun_ispre)();
  
  typedef void* (*engfun_getinterface)(void* engdata); // modengine.h
  typedef int (*engauxfun_interfaceid)();
  typedef void (*engfun_run)(void* data);
  
  typedef void (*auxfun_fillinterface)(void* iface);

  struct module_callbacks {
    modfun_init init_fun;
    modfun_free free_fun;
    modfun_initerr initerr_fun;
    modfun_newdata newdata_fun;
    modfun_freedata freedata_fun;
    modfun_longname longname_fun;
    modfun_author author_fun;
    modfun_doc doc_fun;
    modfun_err err_fun;
    modfun_type type_fun;
    modfun_engine engine_fun;
    modfun_getsetting getsetting_fun;
    modfun_itertype itertype_fun;
    modfun_priority priority_fun;
    modfun_fillinterface mod_fillinterface_fun;
    modfun_interfaceid mod_interfaceid_fun;
    modfun_sameinst sameinst_fun;
    modfun_ready ready_fun;
    modinoutfun_getext getext_fun;
    modinoutfun_getloadid getloadid_fun;
    modinfun_load load_fun;
    modoutfun_write write_fun;
    modoutfun_ispre ispre_fun;
    engfun_getinterface getinterface_fun;
    engauxfun_interfaceid engaux_interfaceid_fun;
    engfun_run run_fun;
    auxfun_fillinterface aux_fillinterface_fun;
  };
  
#ifdef __cplusplus
}
#endif

#endif
